<?php
if (!defined( 'ABSPATH' )) exit;
class woo2app_core_api_coupon {
	public function __construct(){
		add_action( 'init', array( $this , 'woo2app_api_regular_url' ));
		add_filter( 'query_vars', array( $this , 'woo2app_api_query_vars' ));
		add_action( 'parse_request', array( $this , 'woo2app_api_parse_request' ));
	}

	function woo2app_api_regular_url(){
		add_rewrite_rule('', 'index.php?woo2app_coupon', 'top');
	}
	function woo2app_api_query_vars($query_vars){
		$query_vars[] = 'woo2app_coupon';
		return $query_vars;
	}
	function woo2app_api_parse_request(&$wp){
		if ( array_key_exists( 'woo2app_coupon', $wp->query_vars ) ) {
			$this->woo2app_coupon();
			exit();
		}
		return;
	}

	function woo2app_coupon(){
		header('Content-Type: application/json; charset=utf-8');
		$in = $_POST['in'];
		$slashless = stripcslashes($in);
		$url_json = urldecode($slashless);
		$json = (array) json_decode($url_json);

		WC()->cart->empty_cart();
		if (!isset($json["items"])) {
			wp_send_json_error(array('error' => 'سفارش اجباری است.'), 400);
		}
		$line_items = $json["items"];
		$total_price = 0;
		$qtt = 0;
		foreach ($line_items as $product) {
			WC()->cart->add_to_cart($product->product_id, $product->quantity,$product->variation_id);
		}

		$cart = wc()->cart->get_cart();


		foreach($cart as $index => $value){
			$qtt += $value["quantity"];
			$total_price += $value["line_subtotal"];
		}
		if (!isset($json["coupon_code"])) {
			wp_send_json_error(array('error' => 'کوپن اجباری است.'), 400);
		}
		$coupon_code = $json["coupon_code"];//$entity_body->coupon_code;
		$the_coupon = new WC_Coupon($coupon_code);


//-------------------------------------------------
		if (!$the_coupon->is_valid()) {
			wp_send_json_error(array('error' => __('کوپن نا معتبر است .', 'woo2app')), 400);
		} else {
			WC()->cart->add_discount( $json["coupon_code"]);
			$price = (int)wc()->cart->discount_cart;
			wp_send_json_success(array('code' => $json["coupon_code"] , 'id' => $the_coupon->id, 'amount' => $price));
		}
	}

}